/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 22/01/2018
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Hubungan;
import com.portofolio.entity.vo.HubunganId;

@Lazy
@Repository
public interface HubunganDao extends CrudRepository<Hubungan, HubunganId> {

	@Cacheable("HubunganDaofindOneBy")
	Hubungan findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);
	
	Hubungan findOneByIdKdProfileAndIdKodeNotAndNoUrut(Integer kdProfile, Integer kode, Integer noUrut);
	
	@Query(QListAll + " and model.namaHubungan like %:namaHubungan% ")
	@Cacheable("HubunganDaoFindAll")
	Page<Map<String, Object>> findAll(@Param("kdProfile") Integer kdProfile,
			@Param("namaHubungan") String namaHubungan, Pageable page, @Param("kdDepartemen") String kdDepartemen);
	
	@Query(QListAll + " and model.namaHubungan like %:namaHubungan% and model.kdHubunganHead is null ")
	@Cacheable("HubunganDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaHubungan") String namaHubungan, Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaHubungan like %:namaHubungan% and model.kdHubunganHead=:kdHubunganHead")
	@Cacheable("HubunganDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaHubungan") String namaHubungan, Pageable page, @Param("kdDepartemen") String kdDepartemen,
			@Param("kdHubunganHead") Integer kdHubunganHead);

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("HubunganDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	String QListAll = "select new map(model.id.kdHubungan as kdKdHubungan,model.id.kdProfile as kdProfile " + ", model.namaHubungan as namaHubungan "
			+ ", model.reportDisplay as reportDisplay " + ", model.noUrut as noUrut "
			+ ", model.kdHubunganHead as kdHubunganHead" + ", hubunganHead.namaHubungan as namaHubunganHead "
			+ ", model.kodeExternal as kodeExternal " + ", model.namaExternal as namaExternal "
			+ ", model.kdDepartemen as kdDepartemen " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from Hubungan model left join model.id id left join model.departemen departemen left join model.hubunganHead hubunganHead "
			+ " where model.id.kdProfile =:kdProfile and model.kdDepartemen = :kdDepartemen ";

	Hubungan findOneByIdKdProfileAndNoUrut(Integer kdProfile, Integer noUrut);

}
